#ifndef INC_CMMLexer_hpp_
#define INC_CMMLexer_hpp_

#include <antlr/config.hpp>
/* $ANTLR 2.7.4: "CMM.gpp" -> "CMMLexer.hpp"$ */
#include <antlr/CommonToken.hpp>
#include <antlr/InputBuffer.hpp>
#include <antlr/BitSet.hpp>
#include "CMMLexerTokenTypes.hpp"
#include <antlr/CharScanner.hpp>
ANTLR_BEGIN_NAMESPACE(gibbon)
#line 5 "CMM.gpp"

  ANTLR_END_NAMESPACE
  #include "CMM.hpp"
  ANTLR_BEGIN_NAMESPACE(gibbon)

#line 18 "CMMLexer.hpp"
class CUSTOM_API CMMLexer : public antlr::CharScanner, public CMMLexerTokenTypes
{
#line 145 "CMM.gpp"

public:
  bool enable_literals;
  
  virtual int testLiteralsTable (int ttype) const
  {
     if (enable_literals)
        ttype = CharScanner::testLiteralsTable (ttype);
     return ttype;
  }
  
  void LocalInit ()
  {
     enable_literals = true;
  }
#line 22 "CMMLexer.hpp"
private:
	void initLiterals();
public:
	bool getCaseSensitiveLiterals() const
	{
		return true;
	}
public:
	CMMLexer(std::istream& in);
	CMMLexer(antlr::InputBuffer& ib);
	CMMLexer(const antlr::LexerSharedInputState& state);
	antlr::RefToken nextToken();
	public: void mLPAREN(bool _createToken);
	public: void mRPAREN(bool _createToken);
	public: void mLBRACKET(bool _createToken);
	public: void mRBRACKET(bool _createToken);
	public: void mLBRACE(bool _createToken);
	public: void mRBRACE(bool _createToken);
	public: void mDOT(bool _createToken);
	public: void mARROW(bool _createToken);
	public: void mSCOPE(bool _createToken);
	public: void mLOG_NOT(bool _createToken);
	public: void mBIT_NOT(bool _createToken);
	public: void mINC(bool _createToken);
	public: void mDEC(bool _createToken);
	public: void mDOT_STAR(bool _createToken);
	public: void mARROW_STAR(bool _createToken);
	public: void mSTAR(bool _createToken);
	public: void mSLASH(bool _createToken);
	public: void mMOD(bool _createToken);
	public: void mPLUS(bool _createToken);
	public: void mMINUS(bool _createToken);
	public: void mSHL(bool _createToken);
	public: void mSHR(bool _createToken);
	public: void mLESS(bool _createToken);
	public: void mGREATER(bool _createToken);
	public: void mLESS_OR_EQUAL(bool _createToken);
	public: void mGREATER_OR_EQUAL(bool _createToken);
	public: void mEQUAL(bool _createToken);
	public: void mUNEQUAL(bool _createToken);
	public: void mBIT_AND(bool _createToken);
	public: void mBIT_XOR(bool _createToken);
	public: void mBIT_OR(bool _createToken);
	public: void mLOG_AND(bool _createToken);
	public: void mLOG_OR(bool _createToken);
	public: void mASSIGN(bool _createToken);
	public: void mMUL_ASSIGN(bool _createToken);
	public: void mDIV_ASSIGN(bool _createToken);
	public: void mMOD_ASSIGN(bool _createToken);
	public: void mPLUS_ASSIGN(bool _createToken);
	public: void mMINUS_ASSIGN(bool _createToken);
	public: void mSHL_ASSIGN(bool _createToken);
	public: void mSHR_ASSIGN(bool _createToken);
	public: void mBIT_AND_ASSIGN(bool _createToken);
	public: void mBIT_XOR_ASSIGN(bool _createToken);
	public: void mBIT_OR_ASSIGN(bool _createToken);
	public: void mQUESTION(bool _createToken);
	public: void mCOMMA(bool _createToken);
	public: void mCOLON(bool _createToken);
	public: void mSEMICOLON(bool _createToken);
	public: void mDOTS(bool _createToken);
	public: void mLITERAL_49(bool _createToken);
	public: void mWS(bool _createToken);
	public: void mSL_COMMENT(bool _createToken);
	public: void mML_COMMENT(bool _createToken);
	public: void mDIRECTIVE(bool _createToken);
	public: void mCHAR_LITERAL(bool _createToken);
	protected: void mESC(bool _createToken);
	public: void mSTRING_LITERAL(bool _createToken);
	protected: void mOCTAL_DIGIT(bool _createToken);
	protected: void mHEX_DIGIT(bool _createToken);
	protected: void mDIGIT(bool _createToken);
	public: void mIDENT(bool _createToken);
	public: void mNUMBER(bool _createToken);
	protected: void mINTEGER_SUFFIX(bool _createToken);
	protected: void mEXPONENT(bool _createToken);
	protected: void mSUFFIX(bool _createToken);
	protected: void mFLOAT_SUFFIX(bool _createToken);
private:
	
	static const unsigned long _tokenSet_0_data_[];
	static const antlr::BitSet _tokenSet_0;
	static const unsigned long _tokenSet_1_data_[];
	static const antlr::BitSet _tokenSet_1;
	static const unsigned long _tokenSet_2_data_[];
	static const antlr::BitSet _tokenSet_2;
	static const unsigned long _tokenSet_3_data_[];
	static const antlr::BitSet _tokenSet_3;
	static const unsigned long _tokenSet_4_data_[];
	static const antlr::BitSet _tokenSet_4;
	static const unsigned long _tokenSet_5_data_[];
	static const antlr::BitSet _tokenSet_5;
	static const unsigned long _tokenSet_6_data_[];
	static const antlr::BitSet _tokenSet_6;
	static const unsigned long _tokenSet_7_data_[];
	static const antlr::BitSet _tokenSet_7;
	static const unsigned long _tokenSet_8_data_[];
	static const antlr::BitSet _tokenSet_8;
	static const unsigned long _tokenSet_9_data_[];
	static const antlr::BitSet _tokenSet_9;
	static const unsigned long _tokenSet_10_data_[];
	static const antlr::BitSet _tokenSet_10;
};

ANTLR_END_NAMESPACE
#endif /*INC_CMMLexer_hpp_*/
