#ifndef INC_CMMLexerTokenTypes_hpp_
#define INC_CMMLexerTokenTypes_hpp_

ANTLR_BEGIN_NAMESPACE(gibbon)
/* $ANTLR 2.7.4: "CMM.gpp" -> "CMMLexerTokenTypes.hpp"$ */

#ifndef CUSTOM_API
# define CUSTOM_API
#endif

#ifdef __cplusplus
struct CUSTOM_API CMMLexerTokenTypes {
#endif
	enum {
		EOF_ = 1,
		LITERAL_END = 4,
		TXT_WHITE_SPACE = 5,
		TXT_NEW_LINE = 6,
		TXT_TOKEN = 7,
		TXT_OTHER = 8,
		LITERAL_include = 9,
		LITERAL_if = 10,
		LITERAL_ifdef = 11,
		LITERAL_ifndef = 12,
		LITERAL_else = 13,
		LITERAL_endif = 14,
		LITERAL_define = 15,
		LITERAL_undef = 16,
		DIR_WS = 17,
		DIR_SL_COMMENT = 18,
		DIR_ML_COMMENT = 19,
		DIR_NEW_LINE = 20,
		DIR_Q_STRING = 21,
		DIR_H_STRING = 22,
		DIR_IDENT = 23,
		DIR_NUMBER = 24,
		LITERAL_template = 25,
		LITERAL_this = 26,
		LITERAL_dynamic_cast = 27,
		LITERAL_static_cast = 28,
		LITERAL_const_cast = 29,
		LITERAL_reinterpret_cast = 30,
		LITERAL_typeid = 31,
		LITERAL_sizeof = 32,
		LITERAL_new = 33,
		LITERAL_delete = 34,
		LITERAL_case = 35,
		LITERAL_default = 36,
		LITERAL_switch = 37,
		LITERAL_while = 38,
		LITERAL_do = 39,
		LITERAL_for = 40,
		LITERAL_break = 41,
		LITERAL_continue = 42,
		LITERAL_return = 43,
		LITERAL_goto = 44,
		LITERAL_try = 45,
		LITERAL_inline = 46,
		LITERAL_virtual = 47,
		LITERAL_explicit = 48,
		LITERAL_auto = 49,
		LITERAL_register = 50,
		LITERAL_static = 51,
		LITERAL_extern = 52,
		LITERAL_mutable = 53,
		LITERAL_friend = 54,
		LITERAL_typedef = 55,
		LITERAL_const = 56,
		LITERAL_volatile = 57,
		LITERAL_char = 58,
		LITERAL_wchar_t = 59,
		LITERAL_bool = 60,
		LITERAL_short = 61,
		LITERAL_int = 62,
		LITERAL_long = 63,
		LITERAL_signed = 64,
		LITERAL_unsigned = 65,
		LITERAL_float = 66,
		LITERAL_double = 67,
		LITERAL_void = 68,
		LITERAL_enum = 69,
		LITERAL_namespace = 70,
		LITERAL_using = 71,
		LITERAL_typename = 72,
		LITERAL_asm = 73,
		LITERAL_class = 74,
		LITERAL_struct = 75,
		LITERAL_union = 76,
		LITERAL_private = 77,
		LITERAL_protected = 78,
		LITERAL_public = 79,
		LITERAL_operator = 80,
		LITERAL_export = 81,
		LITERAL_catch = 82,
		LITERAL_throw = 83,
		LITERAL_OPEN_NAMESPACE = 84,
		LITERAL_CLOSE_NAMESPACE = 85,
		LITERAL_INTO = 86,
		LITERAL_STORE = 87,
		LITERAL_GROUP = 88,
		LITERAL_COMMENT = 89,
		LITERAL_DEFINE = 90,
		LITERAL_PRIOR = 91,
		LITERAL_EXPRESSION = 92,
		LITERAL_EXPRESSIONS = 93,
		LITERAL_STATEMENT = 94,
		LITERAL_CODE = 95,
		LITERAL_DECLARATION = 96,
		LITERAL_DECLARATIONS = 97,
		LITERAL_PARAMETERS = 98,
		LITERAL_ENUMERATION_TYPE = 99,
		LITERAL_ENUMERATION_ITEMS = 100,
		LITERAL_CLASS = 101,
		LITERAL_BASE = 102,
		LITERAL_PUBLIC = 103,
		LITERAL_PROTECTED = 104,
		LITERAL_PRIVATE = 105,
		LITERAL_ACCESS = 106,
		LITERAL_MEMBER = 107,
		LITERAL_MEMBERS = 108,
		LITERAL_INITIALIZERS = 109,
		LITERAL_INITIALIZER_ITEM = 110,
		LITERAL_INITIALIZER_LIST = 111,
		LITERAL_INDENT = 112,
		LITERAL_SHIFT = 113,
		LITERAL_TEXT_SECTION = 114,
		LITERAL_IDENT = 115,
		LITERAL_TEXT = 116,
		LITERAL_STRING = 117,
		LITERAL_EXPR = 118,
		LITERAL_EXPR_LIST = 119,
		LITERAL_STAT = 120,
		LITERAL_DECL = 121,
		LITERAL_INIT_ITEM = 122,
		LITERAL_INIT_LIST = 123,
		LITERAL_WHEN = 124,
		LITERAL_DO = 125,
		LITERAL_OTHERWISE = 126,
		LITERAL_OR_WHEN = 127,
		LITERAL_CALL = 128,
		LITERAL_SPACE = 129,
		LITERAL_LOCATION = 130,
		LITERAL_SUPER = 131,
		LITERAL_UNINDENT = 132,
		LITERAL_or = 133,
		LITERAL_and = 134,
		LPAREN = 135,
		RPAREN = 136,
		LBRACKET = 137,
		RBRACKET = 138,
		LBRACE = 139,
		RBRACE = 140,
		DOT = 141,
		ARROW = 142,
		SCOPE = 143,
		LOG_NOT = 144,
		BIT_NOT = 145,
		INC = 146,
		DEC = 147,
		DOT_STAR = 148,
		ARROW_STAR = 149,
		STAR = 150,
		SLASH = 151,
		MOD = 152,
		PLUS = 153,
		MINUS = 154,
		SHL = 155,
		SHR = 156,
		LESS = 157,
		GREATER = 158,
		LESS_OR_EQUAL = 159,
		GREATER_OR_EQUAL = 160,
		EQUAL = 161,
		UNEQUAL = 162,
		BIT_AND = 163,
		BIT_XOR = 164,
		BIT_OR = 165,
		LOG_AND = 166,
		LOG_OR = 167,
		ASSIGN = 168,
		MUL_ASSIGN = 169,
		DIV_ASSIGN = 170,
		MOD_ASSIGN = 171,
		PLUS_ASSIGN = 172,
		MINUS_ASSIGN = 173,
		SHL_ASSIGN = 174,
		SHR_ASSIGN = 175,
		BIT_AND_ASSIGN = 176,
		BIT_XOR_ASSIGN = 177,
		BIT_OR_ASSIGN = 178,
		QUESTION = 179,
		COMMA = 180,
		COLON = 181,
		SEMICOLON = 182,
		DOTS = 183,
		LITERAL_49 = 184,
		WS = 185,
		SL_COMMENT = 186,
		ML_COMMENT = 187,
		DIRECTIVE = 188,
		CHAR_LITERAL = 189,
		STRING_LITERAL = 190,
		ESC = 191,
		OCTAL_DIGIT = 192,
		DIGIT = 193,
		HEX_DIGIT = 194,
		IDENT = 195,
		NUMBER = 196,
		EXPONENT = 197,
		INTEGER_SUFFIX = 198,
		FLOAT_SUFFIX = 199,
		SUFFIX = 200,
		NULL_TREE_LOOKAHEAD = 3
	};
#ifdef __cplusplus
};
#endif
ANTLR_END_NAMESPACE
#endif /*INC_CMMLexerTokenTypes_hpp_*/
